#ifndef ROBOTMOTION_LOADED
#define ROBOTMOTION_LOADED

#include "State.h"

#define SIDE_DRIFT      (0.05)
#define ROT_DRIFT       (0.05)
#define DISTANCE_ERROR  (0.15)
#define ANGLE_ERROR     (0.15)
#define ROTATION_ERROR  (0.15)

/////////////////////////////////////////////////////////////////
//  Tools for applying this kind of motion to states.
/////////////////////////////////////////////////////////////////
class PolarMotion {
public:

  PolarMotion( float dist = 0, float ang = 0, float rot = 0);
  PolarMotion( State start, State end);

   void          set( float dist, float ang, float rot);
  
  // Access functions.
   float         distance() const;
   float         angle() const;
   float         rotation() const;

  // Returns the point reached after the motion starting at start.
   State         endPoint( const State& start) const;
   void          apply( State& s) const;
   void          apply( State& s, float fraction) const;
  
private:

  float _distance;      // Distance travelled.
  float _angle;         // Angle to the end point.  
  float _rotation;      // Rotation performed at end point.
};


#endif











