#ifndef FUNCTION_LOADED
#define FUNCTION_LOADED

#include <string>
#ifdef WIN32
using namespace std;
#endif

inline bool fileExists( char* fileName = "_eg");

//----------------------------------------
// Type conversions.
//----------------------------------------

inline int round( double d);

//----------------------------------------
// String handling.
//----------------------------------------

string
numberToString( int digits, int number);

inline string
extractRobotName( const string& str);


//----------------------------------------
// Tools for angle handling.
//----------------------------------------

const double DEG_90  = 1.5707963705;
const double DEG_180 = 3.1415927410;
const double DEG_270 = 4.7123891115;
const double DEG_360 = 6.2831854820;



#ifdef WIN32
#pragma warning(disable : 4005 )
#define M_PI            3.14159265358979323846
#endif

inline float
normalizedAngle( float angle);

inline void
normalizeAngle( float& angle);

inline float
fNorm( float a, float amin, float amax, float bmin, float bmax);
  
//----------------------------------------
// Tools for random numbers.
//----------------------------------------

float
randomGauss();

inline float
randomZeroToOne();

inline int
randomInt( int min, int max);

float
gauss(float x, float sigma, float mean);

//----------------------------------------
// Searching.
//----------------------------------------

int
binarySearch( float* values, float searchVal, int numberOfValues);

//----------------------------------------
// Tools.
//----------------------------------------
inline float
pointDistance( float startX, float endX, float startY, float endY);

inline float
angleDistance( float angle, float angle2);

#endif




